package kernel.peripherals;

import lib.exporter.ExportConfig;
import lib.exporter.IExportable;

class EnergyStorage implements IPeripheral implements IExportable {
	public static inline final TYPE_NAME:String = "energyCell";

	private final addr:String;
	private final native:cc.periphs.EnergyStorage;

	public function new(addr:String) {
		this.addr = addr;
		this.native = cc.Peripheral.wrap(addr);
	}

	public function getEnergy():Int {
		return this.native.getEnergy();
	}

	public function getEnergyCapacity():Int {
		return this.native.getEnergyCapacity();
	}

	public function getAddr():String {
		return this.addr;
	}

	public function getType():String {
		return TYPE_NAME;
	}

	public function export():ExportConfig {
		return {
			getDelegates: [
				"energy" => _ -> Number(this.getEnergy()),
				"capacity" => _ -> Number(this.getEnergyCapacity()),
			],
		}
	}
}
